#include <stdio.h>
#include <stdlib.h>


void setup(int * array,int len)
{
  for (int i=0; i<len; i++)
  {
    array[i]=(i*7-3224)^20435;
  }
}

void bubble_sort(int*array, int N)
{
  int sorted =0;
  while (!sorted)
  {
    sorted=1;
    for (int i=0; i<N-1; i++)
    {
      if (array[i]>array[i+1])
      {
        int temp=array[i+1];
        array[i+1]=array[i];
        array[i]=temp;
        sorted=0;
      }
    }
  }
}

void quick_sort(int * array, int lower, int upper)
{
  int tmp;
  int mid=(upper+lower)/2;
  int pivot = array[mid];
  int tlower=lower, tupper=upper;
  while (tlower<=tupper)
  {
    while (array[tlower]<pivot) {tlower++;}
    while (array[tupper]>pivot) {tupper--;}
    if (tlower<=tupper)
    {
      tmp=array[tlower];
      array[tlower]=array[tupper];
      array[tupper]=tmp;
      tupper--;
      tlower++;
    }
  } 
  if (lower<tupper) {quick_sort(array,lower,tupper);}
  if (tlower<upper) {quick_sort(array,tlower,upper);}
}




int main()
{
  {
    int size=10*1024*1024;
    int * array1=(int*)malloc(sizeof(int)*size);
    setup(array1,size);
    bubble_sort(array1,size);
    int * array2=(int*)malloc(sizeof(int)*size);
    setup(array2,size);
    quick_sort(array2,0,size-1);
    for(int i=0; i<size; i++)
    {
      if (array1[i]!=array2[i]){printf("%i %i %i\n",i, array1[i],array2[i]);}
    }
    getchar();
    return 0;
  }
}
