#include <math.h>
#include <stdio.h>
#include <windows.h>
#include <process.h>

int isprime( int number )
{
  int i;
  for (i = 2; i < (int)( sqrt( (float)number )+1.0 ); i++ )
  {
    if ( number%i == 0) { return 0; }
  }
  return 1;
}
volatile long counter = 0;

unsigned int __stdcall test( void * )
{
  while ( counter<100 )
  {
    int number = InterlockedIncrement( &counter );
    printf( "ThreadID %i; value = %i, is prime = %i\n",
            GetCurrentThreadId(), number, isprime(number) );
  }
  return 0;
}

int _tmain( int argc, _TCHAR* argv[] )
{
   HANDLE h1, h2;
   h1 = (HANDLE)_beginthreadex( 0, 0, &test, (void*)0, 0, 0);
   h2 = (HANDLE)_beginthreadex( 0, 0, &test, (void*)0, 0, 0);
   WaitForSingleObject( h1, INFINITE );
   WaitForSingleObject( h2, INFINITE );
   CloseHandle( h1 );
   CloseHandle( h2 );
   getchar();
   return 0;
}
