#include <windows.h>
#include <process.h>

unsigned int __stdcall fastthread( void * data )
{
  double d=0.0;
  printf( "Fast thread started\n" );
  SetThreadPriority( GetCurrentThread(), THREAD_PRIORITY_ABOVE_NORMAL );
  for (int i=0; i<100000000; i++)
  {
    d += d;
  }
  printf( "Fast thread finished\n" );
  return 0;
}

unsigned int __stdcall slowthread( void * data )
{
  double d=0.0;
  printf( "Slow thread started\n" );
  SetThreadPriority( GetCurrentThread(), THREAD_PRIORITY_BELOW_NORMAL );
  for (int i=0; i<100000000; i++)
  {
    d += d;
  }
  printf( "Slow thread finished\n" );
  return 0;
}

int _tmain( int argc, _TCHAR* argv[] )
{
  HANDLE hfast,hslow;
  hslow = (HANDLE)_beginthreadex( 0, 0, &slowthread, 0, 0, 0 );
  hfast = (HANDLE)_beginthreadex( 0, 0, &fastthread, 0, 0, 0 );
  WaitForSingleObject( hfast, INFINITE );
  WaitForSingleObject( hslow, INFINITE );
  getchar();
  return 0;
}
