#include <stdio.h>

int atomic_add_int( volatile int *address, int value )
{
  asm volatile( "lock xadd %0,%1":"+r"(value):"+m"(*address):"memory" );
  return value;
}

int atomic_inc_int( int *address )
{
  asm volatile ( "lock inc %0": : "+m"(*address): "memory" );
  return (*address);
}

int main()
{
  int i=0;
  atomic_add_int(&i,1);
  atomic_inc_int(&i);
  printf("i=%i\n",i);
}
