#include <unistd.h>
#include <stdio.h>
#include <sys/wait.h>

void main()
{
  int status;
  pid_t f = fork();
  if ( f == 0 )
  { /* Child process */
    execl( "/usr/bin/sleep", "/usr/bin/sleep", "10" );
  }
  else
  {
    waitpid( f, &status, 0 );
    printf( "Status = %i\n", status );
  }
}
