#include <Windows.h>

int _tmain( int argc, _TCHAR* argv[] )
{
  STARTUPINFO startup_info;
  PROCESS_INFORMATION process_info;

  if ( argc>1 )
  {
    wprintf( L"Argument %s\n", argv[1] );
    wprintf( L"Starting child process\n" );
    ZeroMemory( &process_info, sizeof(process_info) );
    ZeroMemory( &startup_info, sizeof(startup_info) );
    startup_info.cb = sizeof(startup_info);

    if (CreateProcess( argv[0], 0, 0, 0, 0, 0, 0, 0,
                       &startup_info, &process_info )==0 ) 
    {
      printf( "ERROR %i\n", GetLastError() );
    }
    WaitForSingleObject( process_info.hProcess, INFINITE );
  }
  else
  {
     printf( "No arguments\n" );
  }
  getchar();
}
