#include <Windows.h>

int _tmain( int argc, _TCHAR* argv[] )
{
  STARTUPINFO startup_info;
  PROCESS_INFORMATION process_info;

  if ( argc==1 )
  {
    printf( "No arguments given starting child process\n" );
    wchar_t argument[256];
    wsprintf( argument, L"\"%s\" Hello", argv[0] );
    ZeroMemory( &process_info, sizeof(process_info) );
    ZeroMemory( &startup_info, sizeof(startup_info) );
    startup_info.cb = sizeof(startup_info);

    if (CreateProcess( argv[0], argument, 0, 0, 0, 0, 0, 0,
                       &startup_info, &process_info )==0 ) 
    {
      printf( "ERROR %i\n", GetLastError() );
    }
    WaitForSingleObject( process_info.hProcess, INFINITE );
  }
  else
  {
    wprintf( L"Argument %s\n", argv[1] );
  }
  getchar();
}
