#ifndef WIN32_LEAN_AND_MEAN
#define WIN32_LEAN_AND_MEAN
#endif
#include <windows.h>
#include <process.h>
#include <winsock2.h>
#include <stdio.h>

#pragma comment( lib, "ws2_32.lib" )

  HANDLE hEvent;
  
void handleecho( void * data )
{
   char buffer[1024];
   int count;
   ZeroMemory( buffer, sizeof(buffer) );
   int socket=(int)data;
   while ( (count = recv( socket, buffer, 1023, 0) ) >0 )
   {
     printf( "Received %s from client\n", buffer );
     int ret = send( socket, buffer, count, 0 );
   }
   printf( "Close echo thread\n" );
   shutdown( socket, SD_BOTH );
   closesocket( socket );
}
  
  
unsigned int __stdcall server( void * data )
{
  SOCKET newsocket; 
  SOCKET ServerSocket =  socket( AF_INET, SOCK_STREAM, 0 ); 

  struct sockaddr_in server;
  ZeroMemory( &server, sizeof(server) );
  server.sin_family = AF_INET; 
  server.sin_addr.s_addr = INADDR_ANY; 
  server.sin_port = 7780; 

  bind( ServerSocket,(struct sockaddr*)&server, sizeof(server) );
  listen( ServerSocket, SOMAXCONN ); 

  SetEvent(hEvent);

  while ( (newsocket = accept( ServerSocket, 0, 0) )!=INVALID_SOCKET )
  {
    HANDLE newthread;
    newthread=(HANDLE)_beginthread( &handleecho, 0, (void*)newsocket);
  }

  printf( "Close server\n" );
  shutdown( ServerSocket, SD_BOTH );
  closesocket( ServerSocket );
  return 0;
}
  
unsigned int __stdcall client( void * data )
{
  SOCKET ConnectSocket = socket( AF_INET, SOCK_STREAM, 0 );
  
  WaitForSingleObject( hEvent, INFINITE );

  struct sockaddr_in server;
  ZeroMemory( &server, sizeof(server) );
  server.sin_family = AF_INET;
  server.sin_addr.s_addr = inet_addr( "127.0.0.1" );
  server.sin_port = 7780;

  connect( ConnectSocket, (struct sockaddr*)&server, sizeof(server) );

  printf( "Sending 'abcd' to server\n" );
  char buffer[1024];
  ZeroMemory( buffer, sizeof(buffer) );
  strncpy_s( buffer, 1024, "abcd", 5 );
  send( ConnectSocket, buffer, strlen(buffer)+1, 0 );
  
  ZeroMemory( buffer, sizeof(buffer) );
  recv( ConnectSocket, buffer, 1024, 0 );
  printf( "Got '%s' from server\n", buffer );

  printf( "Close client\n" );
  shutdown( ConnectSocket, SD_BOTH );
  closesocket( ConnectSocket );
  return 0;
}
 
int _tmain( int argc, _TCHAR* argv[] )
{
  HANDLE serverthread, clientthread;
  WSADATA wsaData;
  
  WSAStartup( MAKEWORD(2,2), &wsaData );
  hEvent = CreateEvent( 0, true, 0, 0 );

  serverthread = (HANDLE)_beginthreadex( 0, 0, &server, 0, 0, 0 );

  clientthread = (HANDLE)_beginthreadex( 0, 0, &client, 0, 0, 0 );
  WaitForSingleObject( clientthread, INFINITE );
  CloseHandle( clientthread );

  CloseHandle( hEvent );
  getchar();
  WSACleanup();
  return 0;
} 
